# mypy-boto3-acm-pca

[![PyPI - mypy-boto3-acm-pca](https://img.shields.io/pypi/v/mypy-boto3-acm-pca.svg?color=blue)](https://pypi.org/project/mypy-boto3-acm-pca)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-acm-pca.svg?color=blue)](https://pypi.org/project/mypy-boto3-acm-pca)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-acm-pca](#mypy-boto3-acm-pca)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.ACMPCA 1.13.25](https://boto3.amazonaws.com/v1/documentation/api/1.13.25/reference/services/acm-pca.html#ACMPCA) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-acm-pca](#mypy-boto3-acm-pca)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `ACMPCA` service.

```bash
python -m pip install boto3-stubs[acm-pca]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_acm_pca` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_acm_pca import ACMPCAClient

# Now mypy can check if your code is valid.
client: ACMPCAClient = boto3.client("acm-pca")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ACMPCAClient = session.client("acm-pca")



# Waiters are also supported

import mypy_boto3_acm_pca.waiter as acm_pca_waiters

audit_report_created_waiter: acm_pca_waiters.AuditReportCreatedWaiter = client.get_waiter("audit_report_created")
certificate_authority_csr_created_waiter: acm_pca_waiters.CertificateAuthorityCSRCreatedWaiter = client.get_waiter("certificate_authority_csr_created")
certificate_issued_waiter: acm_pca_waiters.CertificateIssuedWaiter = client.get_waiter("certificate_issued")


# Annotated paginators are included as well

import mypy_boto3_acm_pca.paginator as acm_pca_paginators

list_certificate_authorities_paginator: acm_pca_paginators.ListCertificateAuthoritiesPaginator = client.get_paginator("list_certificate_authorities")
list_permissions_paginator: acm_pca_paginators.ListPermissionsPaginator = client.get_paginator("list_permissions")
list_tags_paginator: acm_pca_paginators.ListTagsPaginator = client.get_paginator("list_tags")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_acm_pca` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_acm_pca as acm_pca
from mypy_boto3_acm_pca import ACMPCAClient

# with these
from mypy_boto3 import acm_pca
from mypy_boto3.acm_pca import ACMPCAClient
```